program cLazWinDllDemo;

{$mode Delphi} {$H+}

uses
  {$IFDEF LINUX}
  cthreads,
  {$ENDIF}
  Sysutils, Classes, DynLibs;

Type
  pGetCVer         = function (nMode : NativeInt;
                               szRsp : PAnsiChar) : PAnsiChar; stdcall;
  pCAdd            = function (nA, nB : NativeInt) : NativeInt; stdcall;

  pLazLib          = function  (szRsp : PAnsiChar) : PAnsiChar; stdcall;



Var
  hGDllClib    : NativeInt;    // C++Lib HINSTANCE
  hGDllLLib    : NativeInt;    // LazLib HINSTANCE

  FblLoadCLib  : Boolean;
  FblLoadLLib  : Boolean;

  FsGetCVer       : AnsiString;
  FsCAdd          : AnsiString;
  FsLazFnc        : AnsiString;

  FsExe           : AnsiString;
  fsExeName       : AnsiString;
  FsExePath       : AnsiString;
  FsLibName       : AnsiString;
  FsLazLibName    : AnsiString;




Function xLoadCLib(nMode : Longint) : Longint;
begin
  Result := -1;
  If nMode = 1 Then Begin
    hGDllClib :=  LoadLibrary(FsLibName);
    if hGDllClib <> 0 Then Begin
      FblLoadCLib := True;
      FsGetCVer := 'xGetVersionA';
      FsCAdd    := 'xAdd';

      Result := 0;
    end;
  end
  else begin
    If FblLoadCLib = True Then UnLoadLibrary(hGDllClib);
    FblLoadCLib := False;
    Result := 1;
  end;
end;

Function xLoadLazLib(nMode : Longint) : Longint;
begin
  Result := -1;
  If nMode = 1 Then Begin
    hGDllLLib :=  LoadLibrary(FsLazLibName);
    if hGDllLLib <> 0 Then Begin
      FblLoadLLib := True;
      FsLazFnc := 'xLazHelloFncA';

      Result := 0;
    end;
  end
  else begin
    If FblLoadLLib = True Then UnLoadLibrary(hGDllLLib);
    FblLoadLLib := False;
    Result := 1;
  end;
end;

function xCAdd(nA, nB : NativeInt) : NativeInt;
Var
  hDllInst  : NativeInt;  // HINSTANCE
  pxCAdd    : pCAdd; // pCAdd Pointer

begin
  Result := -1;
  hDllInst :=  hGDllClib;
  if hDllInst <> 0 Then Begin
    @pxCAdd := GetProcAddress(hDllInst,  FsCAdd);
    if @pxCAdd <> Nil Then begin
      Result := pxCAdd(nA, nB);
    end;
  end;
end;

function xGetLazHello : AnsiString;
Var
  szRsp     : Array[0..512] of AnsiChar;
  hDllInst  : NativeInt;  // HINSTANCE
  pxLazLib  : pLazLib; // pGetCVerA Pointer

begin
  Result := 'xGetLazHelloA FncError';
  hDllInst :=  hGDllLlib;
  if hDllInst <> 0 Then Begin
    @pxLazLib := GetProcAddress(hDllInst,  FsLazFnc);
    if @pxLazLib <> Nil Then begin
      Result := AnsiString(pxLazLib(PAnsiChar(szRsp)));
    end;
  end;
end;

function xGetCLibVersionA(nMode : NativeInt) : AnsiString;
Var
  szRsp     : Array[0..512] of AnsiChar;
  hDllInst  : NativeInt;  // HINSTANCE
  pxVerA    : pGetCVer; // pGetCVerA Pointer

begin
  Result := 'xGetCVersionA FncError';
  hDllInst :=  hGDllClib;
  if hDllInst <> 0 Then Begin
    @pxVerA := GetProcAddress(hDllInst, FsGetCVer);
    if @pxVerA <> Nil Then begin
      Result := AnsiString(pxVerA(nMode, PAnsiChar(szRsp)));
    end;
  end;
end;


procedure xInit;
begin
  FsExe        := ParamStr(0);
  fsExeName    := ExtractFileName(FsExe);
  FsExePath    := ExtractFilePath(FsExe);
  FsLibName    := FsExePath + 'cDemoLib.dll';
  FsLazLibName := FsExePath + 'LazDemoLib.dll';

  WriteLn('------------------------------------------------------------------');
  WriteLn('Exe       : ' + FsExe);
  WriteLn('ExeName   : ' + FsExeName);
  WriteLn('ExePath   : ' + FsExePath);
  WriteLn('LibCName  : ' + FsLibName);
  WriteLn('LibLName  : ' + FsLazLibName);
  WriteLn('------------------------------------------------------------------');
end;

procedure xRunDll;
begin
  WriteLn('C++ Win64 Dll');
  WriteLn('------------------------------------------------------------------');
  If xLoadCLib(1) = 0 then begin
    WriteLn('Call Function GetVersion : Build = ' + xGetCLibVersionA(1));
    WriteLn('Call Function Add        : Sum   = ' + IntToStr(xCAdd(4, 5)));
    xLoadCLib(0);
  end
  else
    WriteLn('Cannot load : ' + FsLibName);

  WriteLn('------------------------------------------------------------------');
  WriteLn('Lazarus Win64 Dll');
  WriteLn('------------------------------------------------------------------');
  If xLoadLazLib(1) = 0 then begin
    WriteLn('Call Function xLazHelloFncA : Text = ' + xGetLazHello);
    xLoadLazLib(0);
  end
  else
    WriteLn('Cannot load : ' + FsLazLibName);

  WriteLn('------------------------------------------------------------------');
end;

begin
  xInit;
  xRunDll;
end.

